GMSSLeaf (Bouncy Castle Library 1.52 API Specification)
Date: 2015-03-01

org.bouncycastle.pqc.crypto.gmss

## Class GMSSLeaf

- java.lang.Object
- - org.bouncycastle.pqc.crypto.gmss.GMSSLeaf

-     public class GMSSLeaf
      extends java.lang.Object

  This class implements the distributed computation of the public key of the Winternitz one-time signature scheme (OTSS). The class is used by the GMSS classes for calculation of upcoming leafs.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `GMSSLeaf(Digest digest, byte[][] otsIndex, int[] numLeafs)` This constructor regenerates a prior GMSSLeaf object
    `GMSSLeaf(Digest digest, int w, int numLeafs, byte[] seed0)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `byte[]` | `getLeaf()` Returns the leaf value.
    `byte[][]` | `getStatByte()` Returns the status byte array used by the GMSSPrivateKeyASN.1 class
    `int[]` | `getStatInt()` Returns the status int array used by the GMSSPrivateKeyASN.1 class
    `java.lang.String` | `toString()` Returns a String representation of the main part of this element

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### GMSSLeaf

          public GMSSLeaf(Digest digest,
                  byte[][] otsIndex,
                  int[] numLeafs)

      This constructor regenerates a prior GMSSLeaf object
      Parameters:
        `digest` - an array of strings, containing the name of the used hash function and PRNG and the name of the corresponding provider
        `otsIndex` - status bytes
        `numLeafs` - status ints

    - #### GMSSLeaf

          public GMSSLeaf(Digest digest,
                  int w,
                  int numLeafs,
                  byte[] seed0)

  - ### Method Detail

    - #### getLeaf

          public byte[] getLeaf()

      Returns the leaf value.
      Returns:
        the leaf value

    - #### getStatByte

          public byte[][] getStatByte()

      Returns the status byte array used by the GMSSPrivateKeyASN.1 class
      Returns:
        The status bytes

    - #### getStatInt

          public int[] getStatInt()

      Returns the status int array used by the GMSSPrivateKeyASN.1 class
      Returns:
        The status ints

    - #### toString

          public java.lang.String toString()

      Returns a String representation of the main part of this element
      Overrides:
        `toString` in class `java.lang.Object`
      Returns:
        a String representation of the main part of this element